//+------------------------------------------------------------------+
//|                                                    Big_Trend.mq4 |
//|                   Copyright 2005-2010, MetaQuotes Software Corp. |
//|                                              http://www.mql4.com |
//+------------------------------------------------------------------+
#property copyright "Copyright @ 2010, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"


#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Orange
#property indicator_color3 Blue
#property indicator_color4 Orange

#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 2
#property indicator_width4 2

extern int MAPeriod = 16 ;

extern int CCI_Period = 14 ;
extern string Note = "Stoch_K_Period = 5,10 " ;
extern int Stoch_K_Period = 5 ; 
extern string Note2 = "Signal_MODE: 0:SMA;1:EMA;2:SMMA;3:LWMA; " ;
extern int Signal_MODE = MODE_SMA ;
extern string Note3 = "Signal_Period = 15,20,25 " ;
extern int Signal_Period = 15 ; 

double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double Buffer5[];
double Buffer6[];
double Buffer7[];
double Buffer8[];

double Buffer9[];
double Buffer10[];
double Buffer11[];
double Buffer12[];
double Buffer13[];
double Buffer14[];

double Trend[];

int counted_bars = 0;

bool Gi_buy = FALSE;
bool Gi_sell = FALSE;
int limit;

int init() {
   
   IndicatorBuffers(15);
   SetIndexStyle(0, DRAW_LINE);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexStyle(2, DRAW_ARROW);
   SetIndexArrow(2, 108);
   SetIndexStyle(3, DRAW_ARROW);
   SetIndexArrow(3, 108);
   IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS));
   if (MAPeriod < 10) MAPeriod = 10;
   
   IndicatorShortName("Big_Trend(" + MAPeriod + ")");
   SetIndexLabel(0, "UpTrendEnv");
   SetIndexLabel(1, "DnTrendEnv");
   SetIndexLabel(2, "UpSignal");
   SetIndexLabel(3, "DnSignal");
   SetIndexDrawBegin(0, limit);
   SetIndexDrawBegin(1, limit);
   SetIndexDrawBegin(2, limit);
   SetIndexDrawBegin(3, limit);
   SetIndexBuffer(0, Buffer9);
   SetIndexBuffer(1, Buffer10);
   SetIndexBuffer(2, Buffer11);
   SetIndexBuffer(3, Buffer12);
   SetIndexBuffer(4, Buffer13);
   SetIndexBuffer(5, Buffer14);
   
   SetIndexBuffer(6, Buffer1);
   SetIndexBuffer(7, Buffer2);
   SetIndexBuffer(8, Buffer3);
   SetIndexBuffer(9, Buffer4);
   SetIndexBuffer(10, Buffer5);
   SetIndexBuffer(11, Buffer6);
   
   SetIndexBuffer(12, Buffer7);
   SetIndexBuffer(13, Buffer8);
        
   SetIndexBuffer(14, Trend);

   return (0);
}
//------------------
int deinit()
 {
    ObjectDelete("a label");  
    return(0);
 }
//--------------------------
int start() 
{

   int TextSize=20;
   color TextColor1 = Magenta ;
    
   if(ObjectFind("a label") != 0)
   {
      ObjectCreate("a label", OBJ_LABEL, 0,0,0);
      ObjectSetText("a label","Big_Trend " , TextSize, "Arial", TextColor1);
      ObjectSet("a label", OBJPROP_XDISTANCE,450);
     ObjectSet("a label", OBJPROP_YDISTANCE,0);
   }  
  
   if (Bars <= MAPeriod) return (0);
   counted_bars = IndicatorCounted();
   if (counted_bars < 0) return (-1);
   if (counted_bars > 0) counted_bars--;
   limit = Bars - counted_bars;
   
    int right = 5;
   
   for (int i = limit; i >= 1; i--) 
   {

           // double MAUP1 = iEnvelopes(NULL,0,MAPeriod,MODE_SMMA,-40,PRICE_HIGH,MA_Deviation,MODE_UPPER,i);
           double MAUP1 = iMA(NULL,0,MAPeriod,-40,MODE_SMA,PRICE_HIGH,i);              
           double BB_UP = iMA(NULL,0,MAPeriod,0,MODE_SMA,PRICE_HIGH,i+right); 

           double MADN1 = iMA(NULL,0,MAPeriod,-40,MODE_SMA,PRICE_LOW,i);          
           double BB_DN = iMA(NULL,0,MAPeriod,0,MODE_SMA,PRICE_LOW,i+right);   
//------------------------
           double MAUP2 = iMA(NULL,0,MAPeriod,-20,MODE_SMA,PRICE_HIGH,i);
           double BB_UP2 = iMA(NULL,0,MAPeriod,0,MODE_SMA,PRICE_HIGH,i+right);
           
           double MADN2 = iMA(NULL,0,MAPeriod,-20,MODE_SMA,PRICE_LOW,i); 
           double BB_DN2 = iMA(NULL,0,MAPeriod,0,MODE_SMA,PRICE_LOW,i+right); 
                      
//--------------------------------------------------------------------        
         if (MAUP1>BB_UP) {Buffer1[i]=MAUP1; BB_UP=EMPTY_VALUE ;}     
         else {Buffer1[i]=BB_UP ; MAUP1=EMPTY_VALUE ;}
                              
         if( MADN1 >0.0 ) 
         {
          if ( MADN1<BB_DN)  {Buffer2[i]=MADN1; BB_DN=EMPTY_VALUE ;}                        
          else { Buffer2[i]=BB_DN ; MADN1=EMPTY_VALUE ; }
         }
        
         if (MADN1 ==EMPTY_VALUE || MADN1 ==0.0) { Buffer2[i]=BB_DN; MADN1=EMPTY_VALUE ;}          
//------------------------------------------------------------ 
         if (MAUP2>BB_UP2) {Buffer3[i]=MAUP2; BB_UP2=EMPTY_VALUE ;}     
         else {Buffer3[i]=BB_UP2 ; MAUP2=EMPTY_VALUE ;}
                              
         if( MADN2 >0.0 ) 
         {
          if ( MADN2<BB_DN2)  {Buffer4[i]=MADN2; BB_DN2=EMPTY_VALUE ;}                        
          else { Buffer4[i]=BB_DN2 ; MADN2=EMPTY_VALUE ; }
         }
        
         if (MADN2 ==EMPTY_VALUE || MADN2 ==0.0) { Buffer4[i]=BB_DN2; MADN2=EMPTY_VALUE ;}  
//------------------------------------------------------------         
         if(Buffer1[i]>Buffer3[i])  { Buffer5[i]=Buffer1[i];  } else { Buffer5[i]=Buffer3[i];  }
         if(Buffer2[i]<Buffer4[i])  { Buffer6[i]=Buffer2[i];  } else { Buffer6[i]=Buffer4[i];  }

         //Buffer7[i]= iMAOnArray(Buffer5,Bars-1,10,0,MODE_SMA,i);
         //Buffer8[i]= iMAOnArray(Buffer6,Bars-1,10,0,MODE_SMA,i);
              
       Buffer7[i]= (Buffer5[i]+Buffer5[i+1]+Buffer5[i+2]+Buffer5[i+3]+Buffer5[i+4]+Buffer5[i+5]+Buffer5[i+6]+Buffer5[i+7]+Buffer5[i+8]+Buffer5[i+9])/10.0;

       Buffer8[i]= (Buffer6[i]+Buffer6[i+1]+Buffer6[i+2]+Buffer6[i+3]+Buffer6[i+4]+Buffer6[i+5]+Buffer6[i+6]+Buffer6[i+7]+Buffer6[i+8]+Buffer6[i+9])/10.0;
                   
//------------------------------------------------------------      
      Buffer13[i] = iBands(NULL,0,4,2,0,PRICE_HIGH,MODE_UPPER,i);
      Buffer14[i] = iBands(NULL,0,4,2,0,PRICE_LOW ,MODE_LOWER,i);
      
      double CCI = iCCI(NULL,0,CCI_Period,PRICE_CLOSE,i);
      double Stoch = iStochastic(NULL,0,Stoch_K_Period,3,3,MODE_SMA,0,MODE_SIGNAL,i);
      double MAUP = iMA(NULL,0,Signal_Period,0,Signal_MODE,PRICE_HIGH,i); 
      double MADN = iMA(NULL,0,Signal_Period,0,Signal_MODE,PRICE_LOW,i); 
      double OSMA = iOsMA(NULL,0,12,26,9,PRICE_CLOSE,i) ;
            
       Trend[i] = Trend[i + 1];
//---------------------------      
      if (MAUP > Buffer7[i+1] && CCI<0.0 && Stoch<50.0 && OSMA<0.0) Trend[i] = -1;
      if (MADN < Buffer8[i+1] && CCI>0.0 && Stoch>50.0 && OSMA>0.0) Trend[i] = 1; 
      
      //if (CCI<0.0 && Stoch<50.0 && OSMA<0.0) Trend[i] = -1;
      //if (CCI>0.0 && Stoch>50.0 && OSMA>0.0) Trend[i] = 1;         
//---------------------------       
      if (Trend[i] > 0.0) 
      {
         if (Buffer14[i] < Buffer14[i + 1]) Buffer14[i] = Buffer14[i + 1];
         Buffer9[i] = Buffer14[i];
         

            if (Trend[i + 1] < 0.0) 
            {
               Buffer11[i] = Buffer14[i];
               
            } else Buffer11[i] = EMPTY_VALUE;
         
         Buffer10[i] = EMPTY_VALUE;
         Buffer12[i] = EMPTY_VALUE;
      } 
      
      else 
      {
         if (Buffer13[i] > Buffer13[i + 1]) Buffer13[i] = Buffer13[i + 1];
         Buffer10[i] = Buffer13[i];

            if (Trend[i + 1] > 0.0) 
            {
               Buffer12[i] = Buffer13[i];
               
            } else Buffer12[i] = EMPTY_VALUE;
        
         
         Buffer9[i] = EMPTY_VALUE;
         Buffer11[i] = EMPTY_VALUE;
      }
   }
   
   
   if (Trend[2] < 0.0 && Trend[1] > 0.0 && Volume[0] > 1.0 && (!Gi_buy)) 
   {

      Gi_buy = TRUE;
      Gi_sell = FALSE;
   }
   
   
   if (Trend[2] > 0.0 && Trend[1] < 0.0 && Volume[0] > 1.0 && (!Gi_sell)) 
   {

      Gi_sell = TRUE;
      Gi_buy = FALSE;
   }
   
   return (0);
}

//---------------
